unit Ntdll;

{$IMPORTEDDATA OFF}
{$MINENUMSIZE 4}

interface

uses
  Windows;

type
  NTSTATUS = Longint;
  ULONG_PTR = ULONG;
  USHORT = Word;
  PWSTR = PWideChar;

  UNICODE_STRING = record
    Length: USHORT;
    MaximumLength: USHORT;
    Buffer: PWSTR;
  end;

  TProcessInfoClass = (
    ProcessBasicInformation = 0
  );

  TProcessBasicInformation = record
    Reserved1: Pointer;
    PebBaseAddress: Pointer;
    Reserved2: array [0..1] of Pointer;
    UniqueProcessId: ULONG_PTR;
    InheritedFromUniqueProcessId: ULONG_PTR;
  end;

  TSystemInformationClass = (
    SystemTimeOfDayInformation = 3,
    SystemProcessorPerformanceInformation = 8,
    SystemPageFileInformation = 18
  );

  TSystemTimeOfDayInformation = record
    liKeBootTime: TLargeInteger;
    liKeSystemTime: TLargeInteger;
    liExpTimeZoneBias: TLargeInteger;
    uCurrentTimeZoneId: ULONG;
    dwReserved: DWORD;
  end;

  SYSTEM_PROCESSOR_PERFORMANCE_INFORMATION = record
    IdleTime: LARGE_INTEGER;
    KernelTime: LARGE_INTEGER;
    UserTime: LARGE_INTEGER;
    Reserved1: array [0..1] of LARGE_INTEGER;
    Reserved2: ULONG;
  end;
  PSYSTEM_PROCESSOR_PERFORMANCE_INFORMATION = ^SYSTEM_PROCESSOR_PERFORMANCE_INFORMATION;

  SYSTEM_PAGEFILE_INFORMATION = record
    NextEntryOffset: ULONG;
    CurrentSize: ULONG;
    TotalUsed: ULONG;
    PeakUsed: ULONG;
    FileName: UNICODE_STRING;
  end;
  PSYSTEM_PAGEFILE_INFORMATION = ^SYSTEM_PAGEFILE_INFORMATION;

const
  STATUS_INFO_LENGTH_MISMATCH = NTSTATUS($c0000004);

var
  NtCurrentTeb: function: Pointer; stdcall;
  NtQueryInformationProcess: function (ProcessHandle: THandle;
    ProcessInformationClass: TProcessInfoClass; ProcessInformation: Pointer;
    ProcesssInformationLength: ULONG; ReturnLength: PULONG): NTSTATUS; stdcall;
  NtQuerySystemInformation: function (
    SystemInformationClass: TSystemInformationClass;
    SystemInformation: Pointer; SystemInformationLength: ULONG;
    ReturnLength: PULONG): NTSTATUS; stdcall;

implementation

uses NDllLoader;

var
  h: HMODULE;
begin
  h := LoadDLL('ntdll.dll');
  if h = 0 then
    Exit;
  NtCurrentTeb := GetProcAddress(h, 'NtCurrentTeb');
  NtQueryInformationProcess := GetProcAddress(h, 'NtQueryInformationProcess');
  NtQuerySystemInformation := GetProcAddress(h, 'NtQuerySystemInformation');
end.
